#pragma once

#define _export

#if 0
#pragma pack(push, 1)
struct HoHdr
{
  char name[8];
  char type;
  union
  {
    WORD start;
    struct
    {
        char type1;
        char type2;
    };
  };
  WORD length;
  BYTE reserved;
  BYTE noSex;
  WORD checkSum;
};
#pragma pack(pop)
#endif

#include "../shared/types.hpp"

enum Action { do_nothing = 0, do_strip_hobeta, do_extract };

struct DetectorResult
{
    int    structSize;//    
    Action action;//  
    DWORD  internal_id;//    extract  qview
    wchar_t   format [0x80];// assotiation  types.ini (    xTRD) ( xTRD sizeof(value)=128)
    wchar_t   title  [50];//  
    wchar_t   ext    [5];//       (  )
    HoHdr  hdr;//    ,   HRUST 1.x  2.2+
    wchar_t   comment[100];//    xTRD ( xTRD sizeof(comment)=100)
    WORD   noProcessedBytes;//    (   HoBeta)
};

extern "C"
{
    void WINAPI init      (const wchar_t *path);

    bool WINAPI detect    (DetectorResult& result, const wchar_t *file_name, const struct HoHdr *hdr, const BYTE *data, int file_size);
    bool WINAPI extract   (struct HoHdr *hdr, const BYTE *source, DWORD sourceSize, BYTE *unpackBuffer, DWORD *noUnpackedBytes, DWORD internal_id);
//    bool WINAPI quickView (struct HoHdr *hdr, const BYTE *source, DWORD sourceSize, BYTE *unpackBuffer, DWORD *noUnpackedBytes, DWORD internal_id);

    void WINAPI cleanup   (void);
};
